package grado.sti.auxiliar;

import grado.sti.hash.FuncionResumenI;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

/**
 * @author Jorge Lpez Hernndez-Ardieta / adaptacin 2011 Ivn Rivera
 *
 */
public class Clase {
	
	/**
	 * Mtodo que instancia (e inicializa), mediante reflexin, la funcin resumen indicada por la clase pasada como argumento.
	 * El nombre de la clase debe incluir la ruta completa de paquetes hasta la clase dada.
	 * 
	 * @param classFuncionResumen Nombre de la clase concreta (p. ej. grado.sti.hash.FuncionResumenXORBasica)
	 * @return Instancia de la funcin resumen dada, ya inicializada.
	 * @throws ClassNotFoundException
	 * @throws SecurityException
	 * @throws NoSuchMethodException
	 * @throws IllegalArgumentException
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 * @throws InvocationTargetException
	 */
	public static synchronized FuncionResumenI instanciarFuncionResumen(String classFuncionResumen) throws ClassNotFoundException, SecurityException, NoSuchMethodException, IllegalArgumentException, InstantiationException, IllegalAccessException, InvocationTargetException {
		// Instanciacin del objeto que representa la funcin hash concreta mediante reflexin
		Class<?> clase = Class.forName(classFuncionResumen);		
		Constructor<?> constructor = clase.getConstructor((Class<?>[])null);		
		FuncionResumenI funcionResumen = (FuncionResumenI)constructor.newInstance((Object[])null);
		
		funcionResumen.inicializar();
		
		return funcionResumen;
	}
}
