package grado.sti.hash;

/**
 * Interfaz que define el API de una Funcin Resumen.
 * <p>
 * Se limita el tamao del bloque a procesar por la funcin a 8 bytes.
 * <p>
 * El resumen generado ser tambin de 8 bytes.
 * 
 * @author Jorge Lpez Hernndez-Ardieta / adaptacin 2011 Ivn Rivera
 *
 */
public interface FuncionResumenI {
	
	public static final int TAMANYO_BLOQUE = 8;
	
	/**
	 * Mtodo para la inicializacin de la funcin resumen. Se deber invocar antes de poder operar con la funcin resumen.
	 */
	public void inicializar();
	
	/**
	 * Mtodo que calcula el resumen del mensaje de acuerdo al modo de operacin particular.
	 * 
	 * @param mensaje Mensaje sobre el cual calcular el resumen
	 * @return Resumen generado, de 8 bytes de longitud
	 * @throws Exception
	 */
	public byte[] calcularResumen(byte[] mensaje) throws Exception;
}
